﻿using Xamarin.Forms;
using SkiaSharp.Views.Forms;
using SkiaSharp;
using System;
using System.Diagnostics;

namespace test5
{
	public partial class test5Page : ContentPage
	{
		public test5Page()
		{
			InitializeComponent();


			StackLayout s = new StackLayout()
			{
			};

			SKCanvasView skiaview = new SKCanvasView(){
				HorizontalOptions = LayoutOptions.FillAndExpand,
				HeightRequest = 200,
				BackgroundColor = Color.Transparent
			};
			bool pivot = false;
			skiaview.PaintSurface += (object sender, SKPaintSurfaceEventArgs e) => 
			{
				SKCanvas canvas = e.Surface.Canvas;
				canvas.Clear(SKColors.Transparent);

				using (SKPaint paint = new SKPaint())
				{
					paint.Color = SKColors.Red;
					paint.Style = SKPaintStyle.Stroke;
					paint.StrokeWidth = 1;
					if(pivot)
					{
						canvas.DrawLine(0, 0, e.Info.Width, e.Info.Height, paint);
					}
					else
					{
						canvas.DrawLine(0, e.Info.Height, e.Info.Width, 0, paint);
					}
					pivot = !pivot;
				}
			};


			Button b = new Button()
			{
				Text = "redraw view!"
			};
			b.Clicked += (object sender, System.EventArgs e) => {
				skiaview.InvalidateSurface();
			};
			Button b2 = new Button()
			{
				Text = "Renew MainPage"
			};
			b2.Clicked += (object sender, System.EventArgs e) => {
				Application.Current.MainPage = new LoginPage();
			};


			s.Children.Add(skiaview);
			s.Children.Add(b);
			s.Children.Add(b2);

			AbsoluteLayout a = new AbsoluteLayout();
			double r = new Random().NextDouble();
			double g = new Random().NextDouble();
			double bb = new Random().NextDouble();
			a.BackgroundColor = new Color(r, g, bb);
			AbsoluteLayout.SetLayoutFlags(s, AbsoluteLayoutFlags.All);
			AbsoluteLayout.SetLayoutBounds(s, new Rectangle(0.5, 0.5, 1, 1));
			a.Children.Add(s);

			Content = a;

			ToolbarItem item = new ToolbarItem();
			item.Text = "Modal";
			item.Clicked += (object sender, EventArgs e) => {
				var page = new SecondPage();
				page.AddCloseButton();
				Navigation.PushModalAsync(new NavigationPage(page));
			};
			ToolbarItems.Add(item);
		}
	}
}
